<template>
  <div :style="{ backgroundColor: isFieldEdited({ node, path }) ? 'rgba(255, 255, 255, 0.5)' : '' }">
    <div v-if="config">
      <!-- {{ config.label }} -->
      <!-- <pre>{{ config }}</pre> -->

      <div v-if="config.reference" class="reference" :class="'reference-' + config.reference">
      <!-- <div v-if="config.paragraph" class="paragraph"> -->
        {{ config.label }}
        <div v-if="config.multi" class="multi">
          <!-- {{ nodeData }} -->
          <!-- {{ config.ref }} -->
          <!-- {{ typeof nodeData }}
          {{ nodeData }} -->
          <div v-if="isArray(nodeData)">
            <div v-if="nodeData.length">
              <list-items-reference-form :node="node" :path="path"></list-items-reference-form>
            </div>
            <!-- <div v-for="(embed, index) in nodeData" :key="embed.pid" class="paragraph-item">
              <items-paragraph-form :title="config.label + (embed.pid ? ' #' + embed.pid : ' new')" :node="node" :path="[...path, key, index]" :config="config"></items-paragraph-form>
              <delete-item-multi-form :node="node" :path="[...path, key, index]" :config="config"></delete-item-multi-form>
            </div> -->
            <new-item-form :node="node" :path="path"></new-item-form>
          </div>
          <div v-else-if="!isEmpty(nodeData)">
            <items-reference-form :title="config.label + (nodeData && getId(nodeData) ? ' #' + getId(nodeData) : ' new')" :node="node" :path="path"></items-reference-form>
          </div>
          <div v-else>
            <new-item-form :node="node" :path="path"></new-item-form>
          </div>
          <!-- <items-form ></items-form> -->
          <!-- <label>
            {{ fieldsConfig.label }}
            <component :is="'text-field'" :node="node" :config="fieldsConfig"></component>
          </label> -->
        </div>
        <div v-else>
          <div v-if="!isEmpty(nodeData)">
            <items-reference-form :title="config.label + (nodeData && getId(nodeData) ? ' #' + getId(nodeData) : ' new')" :node="node" :path="path"></items-reference-form>
            <delete-item-form :node="node" :path="path"></delete-item-form>
          </div>
          <div v-else>
            <new-item-form :node="node" :path="path"></new-item-form>
          </div>
          <!-- <div v-for="index in (Array.isArray(nodeData) ? nodeData.length - 1 : 0)" :key="index">
            <items-paragraph-form :title="config.label + (nodeData && nodeData[index] ? ' #' + nodeData[index].pid : ' new')" :node="node" :path="[...path, key, index]" :config="config"></items-paragraph-form>
          </div> -->

          <!-- <pre>{{ nodeData }}</pre> -->

        </div>
      </div>
      <div v-else>
        <div v-if="config.multi" class="multi">
          {{ config.label }}
          <div v-if="isArray(nodeData)">
            <div v-if="nodeData.length">
              <list-item-form :node="node" :path="path"></list-item-form>
            </div>

            <!-- <div v-for="(embed, index) in nodeData" :key="embed.nid">
              <item-form :label="config.label + ' #' + (index + 1)" :node="node" :path="[...path, key, index]" :config="config"></item-form>
             <delete-item-multi-form :node="node" :path="[...path, key, index]" :config="config"></delete-item-multi-form>
            </div> -->
            <new-item-form :node="node" :path="path"></new-item-form>
          </div>
          <div v-else-if="!isEmpty(nodeData)">
            <item-form :node="node" :path="path" :config="config"></item-form>
            <!-- <label>
              {{ config.label }} {{ [...path, key, 0] }}
              <component :is="'text-field'" :node="node" :path="[...path, key, 0]" :config="config"></component>

              {{ config.label }} {{ [...path, key, 0] }}
              <component :is="'text-field'" :node="node" :path="[...path, key, 0]" :config="config"></component>
            </label> -->
            <!-- LOOO -->
            <!-- <items-form :title="config.label + ' new'" :node="node" :path="[...path, key, 0]" :config="config"></items-form> -->
          </div>
          <div v-else>
            <new-item-form :node="node" :path="path"></new-item-form>
          </div>
        </div>
        <div v-else>
          <item-form :node="node" :path="path"></item-form>
          <!-- <label>
            {{ config.label }} {{ path }} {{ config.read_only ? 'READ ONLY' : '' }} {{ config.read_only && (!nodeData || nodeData.length === 0) ? 'HIDDEN' : '' }}
            <component :is="'text-field'" :node="node" :path="path" :config="config"></component>
          </label> -->
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapGetters } from 'vuex'

// import TextField from '@/components/Editable/Fields/Widgets/TextFieldWidgetField'

export default {
  components: {
    // TextField,
    ListItemsReferenceForm: () => import('./ListItemsReferenceForm.vue'),
    ListItemForm: () => import('./ListItemForm.vue'),
    ItemsReferenceForm: () => import('./ItemsReferenceForm.vue'),
    ItemsForm: () => import('./ItemsForm.vue'),
    ItemForm: () => import('./ItemForm.vue'),
    NewItemForm: () => import('./NewItemForm.vue'),
    DeleteItemForm: () => import('./DeleteItemForm.vue')
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: false,
      default: () => []
    }
    // config: {
    //   type: Object,
    //   required: true
    // },
    // options: {
    //   type: Object,
    //   required: false,
    //   default: () => {}
    // }
  },

  data () {
    return {
      // excludeList: ['_type', 'nid']
    }
  },
  // watch: {
  //   nodeData: {
  //     handler (val) {
  //       console.log('node')
  //     },
  //     deep: true
  //   }
  // },

  computed: {
    ...mapGetters({
      isFieldEdited: 'Y3TI/isFieldEdited',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    }
    // fieldsConfig () {
    //   return this.config.fields || {}
    // }
    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),
    isEmpty: _.isEmpty,
    isArray: _.isArray,
    // isObject: _.isPlainObject,

    getId (item) {
      return item.pid || item.mid
    }

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
  .reference {
    border: 2px solid black;
    padding: 5px;
  }
  .multi {
    padding: 10px;
    border: 2px solid white;
  }
</style>
